/* This file can be redistributed and used under GNU Library General Public
 * License. (c) 2000 Micha Moskal <malekith@topnet.pl>. 
 * $Id: globals.cc,v 1.11 2001/02/03 17:00:36 malekith Exp $ */

#define _V_PRIVATE

#include <v/v.h>
#include <v/mouse.h>
#include <v/term.h>

#include <unistd.h>

RootWindow v_root_window;
Mouse v_mouse;
void (*v_frame_proc)();

void v_init_config();

void v_init()
{
	init_curses();
	ColorSet::init();
	v_init_config();
	v_mouse.init();
}

void v_die()
{
	v_mouse.die();
	kill_curses();
}

void Widget::do_loop()
{
	draw();
	
	while (!v_root_window.dead && !dead) {
		int c;
		Event e;
		
		if (v_frame_proc)
			v_frame_proc();
			
		v_mouse.think();
		
		if (this == &v_root_window && 
		    v_root_window.remove_dead_children())
			v_root_window.draw();
		
		c = getch();
		
		if (!c) {
			usleep(10000);
			v_root_window.status_line->draw();
			if (v_root_window.active)
				v_root_window.active->time_hook();
			repaint();
			continue;
		}
		
	/*	if (c == key_ctrl('c'))
			throw XDead("bye"); */
			
		e.type = Event::keyboard;
		e.data = c;
		//v_root_window.handle_event(e);
		handle_event(e);
		v_root_window.status_line->draw();
		repaint();
	}
}

void v_xcpt_cought(const char *x);

void Widget::event_loop()
{
	for (;;) {
		try {
			do_loop();
			break;
		} catch (XWidget &e) {
			throw e;
		} catch (XRecover &e) {
			v_xcpt_cought(e.format_self());
		}
	}
}

void v_event_loop()
{
	try {
		if (v_root_window.active == 0 && v_root_window.menu)
			v_root_window.activate(v_root_window.menu);
		v_root_window.event_loop();
	} catch (Exception &e) {
		e.die();
	}
}

