/* This file can be redistributed and used under GNU Library General Public
 * License. (c) 2000 Micha Moskal <malekith@topnet.pl>. 
 * $Id: mouse.cc,v 1.2 2000/09/09 17:59:14 malekith Exp $ */

#define _V_PRIVATE

#include <v/v.h>
#include <v/mouse.h>

#include <gpm.h>
//#include <fcntl.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
		     

void Mouse::init()
{
	Gpm_Connect conn;
	conn.minMod = conn.maxMod = 0;
	conn.eventMask = GPM_DRAG|GPM_UP|GPM_DOWN;
	conn.defaultMask = GPM_MOVE;//~conn.eventMask;
	if (Gpm_Open(&conn, 0) >= 0)
		dead = false;
}

void Mouse::die()
{
	Gpm_Close();
	dead = true;
}

void Mouse::think()
{
	Gpm_Event e;
	int r;
	if (dead || gpm_fd <= 0)
		return;
		
	//fcntl(gpm_fd, F_SETFL, O_NONBLOCK);
	{
	fd_set rd;
	struct timeval tv = { 0, 0 };
	FD_ZERO(&rd); FD_SET(gpm_fd, &rd);
	if (select(gpm_fd + 1, &rd, 0, 0, &tv) < 1)
		return;
	}
		
	r = Gpm_GetEvent(&e);
	if (r == 0)
		dead = 1;
	else if (r == -1)
		{ }
	else
		process_event(&e);
}

void Mouse::process_event(void *_e)
{
	Gpm_Event *e = (Gpm_Event *)_e;
	Event ee;
	
	ee.m.x = e->x - 1;
	ee.m.y = e->y - 1;
	ee.type = Event::mouse;
	
	if ((e->buttons & GPM_B_LEFT) && (e->type & GPM_DOWN)) {
		ee.m.event = Event::MouseState::focus;
		xx = e->x;
		yy = e->y;
	} else if ((e->buttons & GPM_B_LEFT) && (e->type & GPM_DRAG)) {
		if (!some_drag) {
			ee.m.x = xx - 1;
			ee.m.y = yy - 1;
			ee.m.event = Event::MouseState::start_drag;
			send_event(ee);
			ee.m.x = e->x - 1;
			ee.m.y = e->y - 1;
			some_drag = 1;
		}
		ee.m.event = Event::MouseState::drag;
	} else if ((e->buttons & GPM_B_LEFT) && (e->type & GPM_UP)) {
		if (some_drag) {
			ee.m.event = Event::MouseState::end_drag;
			send_event(ee);
			some_drag = 0;
		}
		ee.m.event = Event::MouseState::execute;
	} else if ((e->buttons & GPM_B_RIGHT) && (e->type & GPM_UP))
		ee.m.event = Event::MouseState::popup;
	else
		return;
	
	send_event(ee);
//	GPM_DRAWPOINTER(e);
}
